'---------------------------------------------------------------------------
'  THIS IS THE LIFT SIM WAV TESTER (sound files)
'
' Use this to test the WAV interface directly with QB64.
' All the WAV files that LiftSim uses can be tested here.  If any don't
'  work then you can adjust your WAV file and try it again.
' They must be named exactly as stated in this WAV TESTER application.
'
' Format:
'           (Letter)_(File name).wav
' Example:
'           M_LDG_ARRCHIME_DN.wav
'           O_LDG_ARRCHIME_UP.wav    The first letter assigns the WAV to
'           K_BRAKE_RELEASE.wav      a 'group' of sounds to be chosen in
'                                    LIFTSIM.  The default is "M" which are
'                                    all Mitsubishi sounds, but you can make
'                                    your own.  Maybe start all your WAV
'                                    files with "K_(file name).wav" for Kone?
'
'---------------------------------------------------------------------------
'----------------PRESS F5 TO START------------------------------------------
'---------------------------------------------------------------------------



CLS
SCREEN 12
GOTO jump1:

getwavname:
'help:
'Wav nmbr*      a$=WAV FILE NAME        b$=Description (#=New line)
IF tst = 1 THEN a$ = "LDG_ARRIVECHIME_UP": b$ = "Landing arrival chime - going UP."
IF tst = 2 THEN a$ = "LDG_ARRIVECHIME_DN": b$ = "Landing arrival chime - going DOWN."
IF tst = 3 THEN a$ = "LDG_ARRIVECHIME_UD": b$ = "Landing arrival chime - No onward direction."
IF tst = 4 THEN a$ = "LDG_NEAR_ARRIVECHIME_UP": b$ = "Landing arrival chime of a lift at a nearby floor (echo through shaft) - going UP."
IF tst = 5 THEN a$ = "LDG_NEAR_ARRIVECHIME_DN": b$ = "Landing arrival chime of a lift at a nearby floor (echo through shaft) - going DOWN."
IF tst = 6 THEN a$ = "LDG_NEAR_ARRIVECHIME_UD": b$ = "Landing arrival chime of a lift at a nearby floor (echo through shaft) - No onward direction."
IF tst = 7 THEN a$ = "IN_MOTIONLANDINGCHIME_UP": b$ = "You are in a lift...#this is the echo of the arrival chime on the landing you are approaching (UP tone)."
IF tst = 8 THEN a$ = "IN_MOTIONLANDINGCHIME_DN": b$ = "You are in a lift...#this is the echo of the arrival chime on the landing you are approaching (DOWN tone)."
IF tst = 9 THEN a$ = "IN_MOTIONLANDINGCHIME_UD": b$ = "You are in a lift...#this is the echo of the arrival chime on the landing you are approaching (No onward direction)."
IF tst = 10 THEN a$ = "IN_ARRIVECHIME": b$ = "You are in a lift...#this is the arrival tone (Mitsubishi use it, others don't)."
IF tst = 11 THEN a$ = "IN_DOORCLOSECHIME": b$ = "You are in a lift...#this is the 'doors closing' chime (Mitsubishi use it) or you could make a 'doors closing' voice."
IF tst = 12 THEN a$ = "BRAKE_RELEASE": b$ = "Motor brake release noise.#This only sounds when you get near to the motor room (at the top).  Gets louder the nearer you are."
IF tst = 13 THEN a$ = "BRAKE_APPLY": b$ = "Motor brake apply noise.#This only sounds when you get near to the motor room (at the top).  Gets louder the nearer you are."
IF tst = 14 THEN a$ = "BUTTONPRESS": b$ = "The faint sound when you press a button."

RETURN


jump1:
vo = 100
sel = 1
cl$ = "M"
fn$ = ""
jump2:
renew:
CLS
COLOR 15
PRINT "                         LIFTSIM WAV TESTER (version 1)"
COLOR 13
LOCATE 3, 1: PRINT "Liftsim currently uses these WAV files:"

tst = 0
ttl = 0
mt = 0
rpt:
tst = tst + 1
a$ = ""
GOSUB getwavname:
IF ttl>25 or a$ = "" THEN GOTO nomore:
IF tst = sel THEN fn$ = a$
a$ = a$ + ".wav"

COLOR 7
IF tst = sel THEN pl$ = cl$ + "_" + a$: bb$ = b$: COLOR 14: IF LEN(b$) > mt THEN mt = LEN(b$)
ttl = ttl + 1
LOCATE ttl + 3, 1: PRINT cl$; "_"; a$
GOTO rpt:

nomore:
dnln = 9
FOR v = 2 TO dnln
    COLOR 5
    IF v = 2 OR v = dnln THEN LOCATE v, 44: PRINT STRING$(36, "-")
    LOCATE 2, 46: PRINT "Info on selected WAV:"
    IF v > 2 AND v < dnln THEN LOCATE v, 44: PRINT "|"; STRING$(34, " "); "|"
    COLOR 14: LOCATE 3, 47: PRINT fn$
NEXT v
COLOR 7
LOCATE 10, 40: PRINT "NOTE: If the WAV doesn't exist, it simply"
LOCATE 11, 40: PRINT " doesn't play! Same in Liftsim, so if you"
LOCATE 12, 40: PRINT " don't want a certain sound-don't make it"

COLOR 6
LOCATE 13, 40: PRINT "Most of the WAVs listed vary in volume &"
LOCATE 14, 40: PRINT " direction (L/MID/R) depending where the"
LOCATE 15, 40: PRINT " sound is coming from."
COLOR 15
LOCATE 20, 40: PRINT "PRESS:"
COLOR 11
LOCATE 21, 41: PRINT "UP/DOWN : arrows to select WAV"
COLOR 10
LOCATE 22, 41: PRINT "ENTER   : to play selected WAV"
COLOR 11
LOCATE 23, 41: PRINT "A-Z     : to switch to alternative"
LOCATE 24, 41: PRINT "          WAV set (if it exists)"
LOCATE 25, 41: PRINT "          EG,'M'=Mitsubish,'O'for Otis?"
COLOR 10
LOCATE 26, 41: PRINT "<1  2>  : adjust volume"
COLOR 14
LOCATE 28, 41: PRINT "ESC     : to quit"

dl = 4
da = 45
rd = 0
COLOR 13
rt:
rd = rd + 1
al1 = 0
c$ = " "
IF rd > LEN(bb$) THEN al1 = 1: GOTO np:
c$ = MID$(bb$, rd, 1)
IF c$ = "#" THEN dl = dl + 1: da = 45: GOTO rt:
np:

LOCATE dl, da: PRINT c$
IF al1 = 0 AND da = 45 AND c$ = " " THEN GOTO rt:
da = da + 1
IF da > 78 THEN da = 45: dl = dl + 1:
IF rd <= mt THEN GOTO rt:


k:
ki = 0: key1 = 0: key2 = 0: al2 = 0
k$ = INKEY$
IF k$ <> "" THEN ki = ASC(k$): key1 = ASC(LEFT$(k$, 1)): key2 = ASC(RIGHT$(k$, 1))
IF k$ = "1" THEN vo = vo - 1: IF vo < 0 THEN vo = 0
IF k$ = "2" THEN vo = vo + 1: IF vo > 100 THEN vo = 100
IF ki = 27 THEN GOTO endofprog:
IF ki = 13 THEN GOSUB playit:
IF key1 = 0 AND key2 = 72 THEN IF sel > 1 THEN sel = sel - 1: al2 = 1
IF key1 = 0 AND key2 = 80 THEN IF sel < ttl THEN sel = sel + 1: al2 = 1
IF al2 = 1 THEN GOTO renew:

COLOR 2
LOCATE 18, 40: PRINT "Volume=";
COLOR 10: PRINT vo; "%  "

q$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
COLOR 3
LOCATE 16, 40: PRINT "Using WAV set... ";
COLOR 13: PRINT cl$
FOR v = 1 TO LEN(q$)
    ltr$ = MID$(q$, v, 1)
    COLOR 3
    IF ltr$ = cl$ THEN COLOR 13
    LOCATE 17, 40 + v: PRINT ltr$
    IF UCASE$(k$) = ltr$ THEN cl$ = UCASE$(k$): al2 = 1
NEXT v
IF al2 = 1 THEN GOTO renew

GOTO k:


playit:
COLOR 11:                        '
LOCATE 2, 46: PRINT "PLAYING WAV: @ "; TIME$;
COLOR 3: PRINT " Vol="; MID$(STR$(vo), 2, 3); " "
COLOR 10
LOCATE 3, 45: PRINT pl$
'-------------------------------------------------
'    The following:
'Laff& = _SNDOPEN(pl$, "SYNC,VOL")
'_SNDBAL Laff&, LaffX! 'L,R or both speakers
'_SNDVOL Laff&, (vo/100) 'volume
'_SNDPLAY Laff&
'    ...Should appear below here:

LaffX! = 0
Laff& = _SNDOPEN(pl$, "SYNC,VOL")
_SNDBAL Laff&, LaffX! 'L,R or both speakers
_SNDVOL Laff&, (vo / 100) 'volume
_SNDPLAY Laff&

'-------------did you see it above here?--------------------
'---------If not, you probably run this is QB for DOS-------
'---------...this removes the lines.  Just copy them back---

RETURN

endofprog:
'-------------You have reached the end of the program-----------
'Select FILE > OPEN > and choose a program to open
'                     i.e.  LiftSim, or LiftSim people editor
'OR FILE > EXIT to quit Qbasic
'---------------------------------------------------------------

